diff --git a/src/backend/utils/adt/xml.c b/src/backend/utils/adt/xml.c
index 702b9e3..fa584de 100644
*** a/src/backend/utils/adt/xml.c
--- b/src/backend/utils/adt/xml.c
*************** xml_xmlnodetoxmltype(xmlNodePtr cur)
*** 3280,3286 ****
  		str = xmlXPathCastNodeToString(cur);
  		PG_TRY();
  		{
! 			result = (xmltype *) cstring_to_text((char *) str);
  		}
  		PG_CATCH();
  		{
--- 3280,3286 ----
  		str = xmlXPathCastNodeToString(cur);
  		PG_TRY();
  		{
! 			result = (xmltype *) cstring_to_text(escape_xml((char *) str));
  		}
  		PG_CATCH();
  		{
diff --git a/src/test/regress/expected/xml.out b/src/test/regress/expected/xml.out
index eaa5a74..822f3b4 100644
*** a/src/test/regress/expected/xml.out
--- b/src/test/regress/expected/xml.out
*************** SELECT xpath('//b', '<a>one <b>two</b> t
*** 502,507 ****
--- 502,519 ----
   {<b>two</b>,<b>etc</b>}
  (1 row)
  
+ SELECT xpath('//text()', '<root>&lt;</root>');
+  xpath  
+ --------
+  {&lt;}
+ (1 row)
+ 
+ SELECT xpath('//@value', '<root value="&lt;"/>');
+  xpath  
+ --------
+  {&lt;}
+ (1 row)
+ 
  -- Test xmlexists and xpath_exists
  SELECT xmlexists('//town[text() = ''Toronto'']' PASSING BY REF '<towns><town>Bidford-on-Avon</town><town>Cwmbran</town><town>Bristol</town></towns>');
   xmlexists 
diff --git a/src/test/regress/expected/xml_1.out b/src/test/regress/expected/xml_1.out
index 711b435..d53131c 100644
*** a/src/test/regress/expected/xml_1.out
--- b/src/test/regress/expected/xml_1.out
*************** LINE 1: SELECT xpath('//b', '<a>one <b>t
*** 456,461 ****
--- 456,473 ----
                              ^
  DETAIL:  This functionality requires the server to be built with libxml support.
  HINT:  You need to rebuild PostgreSQL using --with-libxml.
+ SELECT xpath('//text()', '<root>&lt;</root>');
+ ERROR:  unsupported XML feature
+ LINE 1: SELECT xpath('//text()', '<root>&lt;</root>'...
+                                  ^
+ DETAIL:  This functionality requires the server to be built with libxml support.
+ HINT:  You need to rebuild PostgreSQL using --with-libxml.
+ SELECT xpath('//@value', '<root value="&lt;"/>');
+ ERROR:  unsupported XML feature
+ LINE 1: SELECT xpath('//@value', '<root value="&lt;"/>'...
+                                  ^
+ DETAIL:  This functionality requires the server to be built with libxml support.
+ HINT:  You need to rebuild PostgreSQL using --with-libxml.
  -- Test xmlexists and xpath_exists
  SELECT xmlexists('//town[text() = ''Toronto'']' PASSING BY REF '<towns><town>Bidford-on-Avon</town><town>Cwmbran</town><town>Bristol</town></towns>');
  ERROR:  unsupported XML feature
diff --git a/src/test/regress/sql/xml.sql b/src/test/regress/sql/xml.sql
index 717a1e7..40e711a 100644
*** a/src/test/regress/sql/xml.sql
--- b/src/test/regress/sql/xml.sql
*************** SELECT xpath('', '<!-- error -->');
*** 163,168 ****
--- 163,170 ----
  SELECT xpath('//text()', '<local:data xmlns:local="http://127.0.0.1"><local:piece id="1">number one</local:piece><local:piece id="2" /></local:data>');
  SELECT xpath('//loc:piece/@id', '<local:data xmlns:local="http://127.0.0.1"><local:piece id="1">number one</local:piece><local:piece id="2" /></local:data>', ARRAY[ARRAY['loc', 'http://127.0.0.1']]);
  SELECT xpath('//b', '<a>one <b>two</b> three <b>etc</b></a>');
+ SELECT xpath('//text()', '<root>&lt;</root>');
+ SELECT xpath('//@value', '<root value="&lt;"/>');
  
  -- Test xmlexists and xpath_exists
  SELECT xmlexists('//town[text() = ''Toronto'']' PASSING BY REF '<towns><town>Bidford-on-Avon</town><town>Cwmbran</town><town>Bristol</town></towns>');
